﻿using CommunityToolkit.Mvvm.Input;
using FlyXray;
using GeneralGommunication;
using System.ComponentModel;
using System.Windows.Controls;
using System.Windows.Threading;

namespace AD2021.B2.TestApp
{
    /// <summary>
    /// PgTurntable.xaml 的交互逻辑
    /// </summary>
    public partial class PgFlyXray : Page
    {
        PgFlyXrayVm viewModel;
        public PgFlyXray()
        {
            InitializeComponent();
        }

        [Unity.InjectionMethod]
        public void Init(ModbusAsciiAsyncConnector connector, FlyXrayUnit flyXray)
        {
            viewModel = new PgFlyXrayVm();
            viewModel.Init(connector, flyXray);
            this.DataContext = viewModel;

            ucFlyXray0.Init("#1", flyXray);


        }
    }
    public class PgFlyXrayVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;


        public RelayCommand ConnectCmd { get; private set; }
        public RelayCommand DisconnectCmd { get; private set; }




        public ModbusAsciiAsyncConnector Connector => connector;
        public FlyXrayUnit FlyXray => flyXray;

        ModbusAsciiAsyncConnector connector;
        FlyXrayUnit flyXray;

        DispatcherTimer timer;
        public PgFlyXrayVm()
        {
            ConnectCmd = new RelayCommand(Connect);
            DisconnectCmd = new RelayCommand(Disconnect);
        }



        public void Init(ModbusAsciiAsyncConnector _connector, FlyXrayUnit _flyXray)
        {
            connector = _connector;
            flyXray = _flyXray;

        }

        private void Disconnect()
        {
            connector.Disconnect();
        }

        private void Connect()
        {
            connector.Connect();
            connector.Save();
        }
    }
}
