﻿using CommunityToolkit.Mvvm.Input;
using FlyXray;
using System.ComponentModel;
using System.Windows.Controls;

namespace AD2021.B2.TestApp
{
    /// <summary>
    /// UcFlyXray.xaml 的交互逻辑
    /// </summary>
    public partial class UcFlyXray : UserControl
    {
        UcFlyXrayVm viewModel;
        public UcFlyXray()
        {
            InitializeComponent();
        }

        public void Init(string name, FlyXrayUnit unit)
        {
            viewModel = new UcFlyXrayVm();
            viewModel.Init(name, unit);
            this.DataContext = viewModel;
        }
    }
    public class UcFlyXrayVm : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public string Name { get; private set; }

        public RelayCommand GetParamCmd { get; private set; }

        public FlyXrayUnit Unit => unit;

        FlyXrayUnit unit;
        public UcFlyXrayVm()
        {
            GetParamCmd = new RelayCommand(GetParam);
        }



        public void Init(string name, FlyXrayUnit _unit)
        {
            Name = name;
            unit = _unit;
        }


        private void GetParam()
        {
            WdFlyXrayParam w = new WdFlyXrayParam();
            w.Init(Name, unit.Core);
            w.Owner = App.Current.MainWindow;
            w.ShowDialog();
        }


    }
}
