﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace Misc
{
    //字符串转换
    public class StringConverter
    {
        private const string blank = @"\s*";
        private const string num = @"\d+";

        // 摘要:
        //     将主机名或 IP 地址解析为 IPEndPoint 实例。
        public static IPEndPoint ToIPEndPoint(string hostNameOrAddress)
        {
            if (string.IsNullOrEmpty(hostNameOrAddress))
                return null;

            string[] s = hostNameOrAddress.Split(new char[] { ':' }, StringSplitOptions.RemoveEmptyEntries);
            if (s.Length == 1)
            {
                IPAddress ip;
                int port = 20006;
                try
                {
                    ip = IPAddress.Parse(s[0]);
                }
                catch
                {
                    try
                    {
                        IPAddress[] ips = System.Net.Dns.GetHostEntry(s[0]).AddressList;
                        if (ips.Length == 1)
                            ip = ips[0];
                        else
                            ip = IPAddress.Parse("127.0.0.1");
                    }
                    catch
                    {
                        return null;
                    }
                }
                return new IPEndPoint(ip, port);

            }
            else if (s.Length == 2)
            {
                IPAddress ip;
                int port;
                try
                {
                    port = int.Parse(s[1]);
                }
                catch
                {
                    return null;
                }
                try
                {
                    ip = IPAddress.Parse(s[0]);
                }
                catch
                {
                    try
                    {
                        IPAddress[] ips = System.Net.Dns.GetHostEntry(s[0]).AddressList;
                        if (ips.Length == 1)
                            ip = ips[0];
                        else
                            ip = IPAddress.Parse("127.0.0.1");
                    }
                    catch
                    {
                        return null;
                    }
                }
                return new IPEndPoint(ip, port);
            }
            return null;
        }

        public static string IPEndPoint2DirectoryName(IPEndPoint ipep)
        {
            return ipep.Address.ToString() + "_" + ipep.Port.ToString();
        }
    }
}
