﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.IO.Ports;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FlyAdXBase
{
    public interface IFlyAd2021 : INotifyPropertyChanged
    {
        /// <summary>
        /// 从flyad7 获取 的systick 转换的时间
        /// </summary>
        DateTime Now { get; }
        UInt16 AD { get; }
        UInt16 ENC1 { get; }
        UInt16 ENC2 { get; }
        UInt16 In { get; }
        UInt16 Out { get; }


        /// <summary>
        /// 通过systick 判断复位次数，
        /// Now的复位次数
        /// </summary>
        int ResetCnt { get; }
        /// <summary>
        /// timegrid 事件; 版本2021: 0.2s 一次
        /// </summary>
        event TimeGridEventHandler TimeGridEvent;


        /// <summary>
        ///  通讯速度 byte/s
        /// </summary>
        double CommSpeed { get; }

        /// <summary>
        /// 传输速度 单位 pack/s
        /// </summary>
        double PackSpeed { get; }

        /// <summary>
        /// 包出错次数
        /// </summary>
        int ErrCnt { get; }

        event PackEventHandler RecPackEvent;
        event PackEventHandler FuncSendPackEvent;
        event PackEventHandler FuncRecPackEvent;
    }
}
